/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef _SLIBOPREF_H_
#define _SLIBOPREF_H_

#include <kdialogbase.h>
#include <qframe.h>

class SliboPrefPageOne;
class SliboPrefPageTwo;
class slibo;
class QButtonGroup;
class QCheckBox;
class QSlider;
class QHBoxLayout;

class SliboPreferences : public KDialogBase
{
    Q_OBJECT
public:
    SliboPreferences(slibo *);

    SliboPrefPageOne *m_pageOne;
    SliboPrefPageTwo *m_pageTwo;
};

class SliboPrefPageOne : public QFrame
{
    Q_OBJECT
public:
    SliboPrefPageOne(QWidget *parent, slibo*);
    void connectWidgets();
    QButtonGroup *bg;
    QHBoxLayout *hbox;
    QWidget *central;
    slibo *theApp;
};

class SliboPrefPageTwo : public QFrame
{
    Q_OBJECT
public:
    SliboPrefPageTwo(QWidget *parent, slibo*);
};

#endif // _SLIBOPREF_H_
