%include        "macros.asm"
;%define         DOUBLEHASH

extern          printf
extern          mainHash
global          putpiece
global          clrpiece
global          movepiece
global          prehash


;******************************************************************************

%macro          setAttackflag   4
                mov             eax,ecx                                         ;store value for Attacking piece /w BISHOP/ROOK
                mov             esi,ebp
                sub             eax,dword[ebx+AttackVec+ATYPE*%4 - COLORI*%3]   ;sub value of already in that direction Attacking piece
                sub             esi,dword[ebx+AttackVec+ATYPE*%4 - COLORI*%3 + COLORI];we might block it
                mov             edx,dword[ebx+AttackVec+ATYPE*%4 + COLORI*%3]   ;get value of piece attacing the oppsite Color (our own Pieces)
                mov             edi,dword[ebx+AttackVec+ATYPE*%4 + COLORI*%3 + COLORI]
%assign         off             %1
%rep            6
                add             dword[ebx+Attacks+off-   %2*ATYPE*%3],eax       ;add to old difference between new and old to get new
                add             dword[ebx+Attacks+off-QUEEN*ATYPE*%3],esi
                sub             dword[ebx+Attacks+off+   %2*ATYPE*%3],edx
                sub             dword[ebx+Attacks+off+QUEEN*ATYPE*%3],edi
                cmp             dword[ebx+Board+off],0
                mov             dword[ebx+AttackVec+off + ATYPE*%4 - COLORI*%3],ecx  ;overwrite old vector
                mov             dword[ebx+AttackVec+off + ATYPE*%4 - COLORI*%3 + COLORI],ebp
                mov             dword[ebx+AttackVec+off + ATYPE*%4 + COLORI*%3],0
                mov             dword[ebx+AttackVec+off + ATYPE*%4 + COLORI*%3 + COLORI],0
                jne             %%endAttackrow
%assign         off             off+%1
%endrep
                add             dword[ebx+Attacks+off-   %2*ATYPE*%3],eax       ;add to old difference between new and old to get new
                add             dword[ebx+Attacks+off-QUEEN*ATYPE*%3],esi
                sub             dword[ebx+Attacks+off+   %2*ATYPE*%3],edx
                sub             dword[ebx+Attacks+off+QUEEN*ATYPE*%3],edi
                mov             dword[ebx+AttackVec+off + ATYPE*%4 - COLORI*%3],ecx  ;overwrite old vector
                mov             dword[ebx+AttackVec+off + ATYPE*%4 - COLORI*%3 + COLORI],ebp
                mov             dword[ebx+AttackVec+off + ATYPE*%4 + COLORI*%3],0
                mov             dword[ebx+AttackVec+off + ATYPE*%4 + COLORI*%3 + COLORI],0
%%endAttackrow:
%endmacro


;*****************************************************************************
%macro          setAttackvec2   3
                mov             edx,[edi + AttackBy + ATYPE*%2]
                sub             edx,%3                  ;case %3 = 0 (ecx) :if no vector set, all fields will be empty, so we dont need to clear the vector
                je              %%Att0                ;case %3 = ATTACK: if exactly the same Attack was stored there before, we dont need to change anything (only happen with 2 rooks)
                mov             eax,[edi + AttackLen + ATYPE*%2]
                mov             ebp,[edi + AttackLen + ATYPE*(((%2+3)%8)+1)];attacklen of counter direction
                jmp             [%%AttJmpTable+eax*4]
%%AttJmpTable:  dd              %%Att0, %%Att1, %%Att2, %%Att3, %%Att4, %%Att5, %%Att6, %%Att7
%%Att7:         sub             [edi + AttackBy + 7*%1],edx
                mov             dword[edi + AttackBy + ATYPE*%2 + 7*%1],%3
                sub             [edi + AttackLen + ATYPE*%2 + 7*%1], ebp
%%Att6:         sub             [edi + AttackBy + 6*%1],edx
                mov             dword[edi + AttackBy + ATYPE*%2 + 6*%1],%3
                sub             [edi + AttackLen + ATYPE*%2 + 6*%1], ebp
%%Att5:         sub             [edi + AttackBy + 5*%1],edx
                mov             dword[edi + AttackBy + ATYPE*%2 + 5*%1],%3
                sub             [edi + AttackLen + ATYPE*%2 + 5*%1], ebp
%%Att4:         sub             [edi + AttackBy + 4*%1],edx
                mov             dword[edi + AttackBy + ATYPE*%2 + 4*%1],%3
                sub             [edi + AttackLen + ATYPE*%2 + 4*%1], ebp
%%Att3:         sub             [edi + AttackBy + 3*%1],edx
                mov             dword[edi + AttackBy + ATYPE*%2 + 3*%1],%3
                sub             [edi + AttackLen + ATYPE*%2 + 3*%1], ebp
%%Att2:         sub             [edi + AttackBy + 2*%1],edx
                mov             dword[edi + AttackBy + ATYPE*%2 + 2*%1],%3
                sub             [edi + AttackLen + ATYPE*%2 + 2*%1], ebp
%%Att1:         sub             [edi + AttackBy + 1*%1],edx
                mov             dword[edi + AttackBy + ATYPE*%2 + 1*%1],%3
                sub             [edi + AttackLen + ATYPE*%2 + 1*%1], ebp
%%Att0:
%endmacro
;*****************************************************************************
%macro          setAttackvec    3
                mov             edx,[edi + AttackBy + ATYPE*%2]
                sub             edx,%3                  ;case %3 = 0 (ecx) :if no vector set, all fields will be empty, so we dont need to clear the vector
                je              %%endvec                ;case %3 = ATTACK: if exactly the same Attack was stored there before, we dont need to change anything (only happen with 2 rooks)
%assign         off             %1
%rep            6
                sub             [edi + AttackBy + off],edx
                cmp             ecx,[edi + Board + off]
                mov             dword[edi + AttackBy + ATYPE*%2 + off],%3
                jne             %%endvec
%assign         off             off+%1
%endrep
                sub             [edi + AttackBy + off],edx
                mov             dword[edi + AttackBy + ATYPE*%2 + off],%3
                jmp             short %%endvec
                align           8
%%endvec:
%endmacro
;******************************************************************************

%macro          putpiece_m        2                    ;Color

%assign         PAWN_ATTACK     1<<(8-8*%1)            ;2
%assign         BISHOP_ATTACK   1<<(2+8-8*%1)           ;1
%assign         KNIGHT_ATTACK   1<<(5+8-8*%1)            ;2
%assign         ROOK_ATTACK     1<<(8+8-8*%1)             ;2 bits for rooks
%assign         QUEEN_ATTACK    1<<(11+8-8*%1)             ;1
%assign         KING_ATTACK     1<<(14+8-8*%1)           ;1

;counter Attacks
%assign         PAWN_CATTACK     1<<(8+8*%1)            ;2
%assign         BISHOP_CATTACK   1<<(2+8+8*%1)           ;1
%assign         KNIGHT_CATTACK   1<<(5+8+8*%1)            ;2
%assign         ROOK_CATTACK     1<<(8+8+8*%1)             ;2 bits for rooks
%assign         QUEEN_CATTACK    1<<(11+8+8*%1)             ;1
%assign         KING_CATTACK     1<<(14+8+8*%1)           ;1


                pusha
                mov             eax,[esp+36]           ;type
                mov             edi,[esp+40]           ;destination
                shl             eax,6                  ;*piecelsize
                mov             ecx,[eax+Pieces]       ;# of Pieces of this type
                inc             dword[eax+Pieces]      ;inc # of Pieces of this type
                mov             [eax+ecx*4+Pieces+4],edi      ;store position in pieveList
                shl             eax,3                  ;ecx = piece * BMEM
                mov             [edi + Board   ],ax    ;store piece in Board
                mov             [edi + Board +2],ax

                lea             ecx,[eax*2 + 6*ATYPE + hashKeys]

                movq            mm0,[mainHashKey]
                pxor            mm0,[ecx + 2*edi]
                movq            [mainHashKey],mm0
                movq            mm0,[pawnHashKey]
                pxor            mm0,[ecx + 2*edi + 64]
                movq            [pawnHashKey],mm0
                emms

                xor             ecx,ecx
                sar             eax,7
                jmp             [eax+putJmpTable]             
                
                align           8
putRook%2:      setAttackvec    row, 1, ROOK_ATTACK
                setAttackvec    col, 3, ROOK_ATTACK
                setAttackvec    -row,5, ROOK_ATTACK
                setAttackvec    -col,7, ROOK_ATTACK
                setAttackvec    row+col, 2, ecx
                setAttackvec    -row+col,4, ecx
                setAttackvec    -row-col,6, ecx
                setAttackvec    row-col, 8, ecx
                popa
                ret

                align           8
putBishop%2:    setAttackvec    row+col, 2, BISHOP_ATTACK
                setAttackvec    -row+col,4, BISHOP_ATTACK
                setAttackvec    -row-col,6, BISHOP_ATTACK
                setAttackvec    row-col, 8, BISHOP_ATTACK
                setAttackvec    row, 1, ecx
                setAttackvec    col, 3, ecx
                setAttackvec    -row,5, ecx
                setAttackvec    -col,7, ecx
                popa
                ret
                
                align           8
putQueen%2:     setAttackvec    row,    1,QUEEN_ATTACK
                setAttackvec    col,    3,QUEEN_ATTACK
                setAttackvec    -row,   5,QUEEN_ATTACK
                setAttackvec    -col,   7,QUEEN_ATTACK
                setAttackvec    row+col, 2,QUEEN_ATTACK
                setAttackvec    -row+col,4,QUEEN_ATTACK
                setAttackvec    -row-col,6,QUEEN_ATTACK
                setAttackvec    row-col, 8,QUEEN_ATTACK
                popa
                ret

                align           8
putKnight%2:    add             dword[edi + AttackBy + 2*row +   col], KNIGHT_ATTACK
                add             dword[edi + AttackBy + 2*row -   col], KNIGHT_ATTACK
                add             dword[edi + AttackBy - 2*row +   col], KNIGHT_ATTACK
                add             dword[edi + AttackBy - 2*row -   col], KNIGHT_ATTACK
                add             dword[edi + AttackBy + 1*row + 2*col], KNIGHT_ATTACK
                add             dword[edi + AttackBy + 1*row - 2*col], KNIGHT_ATTACK
                add             dword[edi + AttackBy - 1*row + 2*col], KNIGHT_ATTACK
                add             dword[edi + AttackBy - 1*row - 2*col], KNIGHT_ATTACK
                jmp            %%clrvecs

                align           8
putKing%2:      add             dword[edi + AttackBy + row +   col], KING_ATTACK
                add             dword[edi + AttackBy + row -   col], KING_ATTACK
                add             dword[edi + AttackBy - row +   col], KING_ATTACK
                add             dword[edi + AttackBy - row -   col], KING_ATTACK
                add             dword[edi + AttackBy + row], KING_ATTACK
                add             dword[edi + AttackBy - row], KING_ATTACK
                add             dword[edi + AttackBy + col], KING_ATTACK
                add             dword[edi + AttackBy - col], KING_ATTACK
                jmp             %%clrvecs

                align           8
putPawn%2:      add             dword[edi + AttackBy + %1*row +   col], PAWN_ATTACK
                add             dword[edi + AttackBy + %1*row -   col], PAWN_ATTACK

%%clrvecs:      setAttackvec    row,    1,ecx
                setAttackvec    col,    3,ecx
                setAttackvec    -row,   5,ecx
                setAttackvec    -col,   7,ecx
                setAttackvec    row+col, 2,ecx
                setAttackvec    -row+col,4,ecx
                setAttackvec    -row-col,6,ecx
                setAttackvec    row-col, 8,ecx
                popa
                ret

%ifdef          attacks
                mov             edi,[esp+36]
                neg             edi
                cmovs           edi,[esp+36]
                mov             [temp],edi
                mov             ebp,[edi*4 + attack_q_file]
                mov             ecx,[edi*4 + attack_r]
                setAttackflag    col, ROOK ,%1, 0
                setAttackflag    row, ROOK ,%1, 2
                setAttackflag   -col, ROOK ,%1, 4
                setAttackflag   -row, ROOK ,%1, 6

                mov             edi,[temp]
                mov             ebp,[edi*4 + attack_q_dia]
                mov             ecx,[edi*4 + attack_b]
                setAttackflag    row+col, BISHOP ,%1, 1
                setAttackflag    row-col, BISHOP ,%1, 3
                setAttackflag   -row-col, BISHOP ,%1, 5
                setAttackflag   -row+col, BISHOP ,%1, 7

                mov             edi,[temp]
                mov             eax,[edi*4 + attack_n]
                add             dword[ebx+Attacks + 2*row +   col - KNIGHT*ATYPE*%1], eax
                add             dword[ebx+Attacks + 2*row -   col - KNIGHT*ATYPE*%1], eax
                add             dword[ebx+Attacks - 2*row +   col - KNIGHT*ATYPE*%1], eax
                add             dword[ebx+Attacks - 2*row -   col - KNIGHT*ATYPE*%1], eax
                add             dword[ebx+Attacks + 1*row + 2*col - KNIGHT*ATYPE*%1], eax
                add             dword[ebx+Attacks + 1*row - 2*col - KNIGHT*ATYPE*%1], eax
                add             dword[ebx+Attacks - 1*row + 2*col - KNIGHT*ATYPE*%1], eax
                add             dword[ebx+Attacks - 1*row - 2*col - KNIGHT*ATYPE*%1], eax

                mov             eax,[edi*4 + attack_p]
                add             dword[ebx+Attacks + %1*row + col - PAWN*ATYPE*%1], eax
                add             dword[ebx+Attacks + %1*row - col - PAWN*ATYPE*%1], eax

                popa
                ret
%endif

%endmacro

;********************************************************************************************

%macro          clrAttackflag   4
                mov             eax,dword[ebx+AttackVec+ATYPE*%4 - COLORI*%3]   ;old val
                mov             esi,dword[ebx+AttackVec+ATYPE*%4 - COLORI*%3 + COLORI];
                sub             ecx,eax
                sub             ebp,esi
                mov             edx,dword[ebx+AttackVec+ATYPE*%4 + COLORI*%3]   ;get value of piece attacing the oppsite Color (our own Pieces)
                mov             edi,dword[ebx+AttackVec+ATYPE*%4 + COLORI*%3 + COLORI]
%assign         off             %1
%rep            6
                sub             dword[ebx+Attacks+off-   %2*ATYPE*%3],ecx       ;new - (new - old)
                sub             dword[ebx+Attacks+off-QUEEN*ATYPE*%3],ebp
                add             dword[ebx+Attacks+off+   %2*ATYPE*%3],edx
                add             dword[ebx+Attacks+off+QUEEN*ATYPE*%3],edi
                cmp             dword[ebx+Board+off],0
                mov             dword[ebx+AttackVec+off + ATYPE*%4 - COLORI*%3],eax  ;overwrite old vector
                mov             dword[ebx+AttackVec+off + ATYPE*%4 - COLORI*%3 + COLORI],esi
                mov             dword[ebx+AttackVec+off + ATYPE*%4 + COLORI*%3],edx     ;restore old vector
                mov             dword[ebx+AttackVec+off + ATYPE*%4 + COLORI*%3 + COLORI],edi
                jne             %%endAttackrow
%assign         off             off+%1
%endrep
                sub             dword[ebx+Attacks+off-   %2*ATYPE*%3],ecx       ;new - (new - old)
                sub             dword[ebx+Attacks+off-QUEEN*ATYPE*%3],ebp
                add             dword[ebx+Attacks+off+   %2*ATYPE*%3],edx
                add             dword[ebx+Attacks+off+QUEEN*ATYPE*%3],edi
                mov             dword[ebx+AttackVec+off + ATYPE*%4 - COLORI*%3],eax  ;overwrite old vector
                mov             dword[ebx+AttackVec+off + ATYPE*%4 - COLORI*%3 + COLORI],esi
                mov             dword[ebx+AttackVec+off + ATYPE*%4 + COLORI*%3],edx     ;restore old vector
                mov             dword[ebx+AttackVec+off + ATYPE*%4 + COLORI*%3 + COLORI],edi
%%endAttackrow:
                add             ecx,eax
                add             ebp,esi
%endmacro


;*****************************************************************************
%macro          clrAttackvec2   3
                mov             edx,[esi + AttackBy + ATYPE*%2]
                mov             ebp,edx
                sub             edx,%3                  ;case %3 = 0 (ecx) :if no vector set, all fields will be empty, so we dont need to clear the vector
                je              %%Att0                ;case %3 = ATTACK: if exactly the same Attack was stored there before, we dont need to change anything (only happen with 2 rooks)
                mov             eax,[esi + AttackLen + ATYPE*%2]
                mov             ecx,[esi + AttackLen + ATYPE*(((%2+3)%8)+1)];attacklen of counter direction
                jmp             [%%AttJmpTable+eax*4]
%%AttJmpTable:  dd              %%Att0, %%Att1, %%Att2, %%Att3, %%Att4, %%Att5, %%Att6, %%Att7
%%Att7:         add             [esi + AttackBy + 7*%1],edx
                mov             dword[esi + AttackBy + ATYPE*%2 + 7*%1],ebp
                add             [esi + AttackLen + ATYPE*%2 + 7*%1], ecx
%%Att6:         add             [esi + AttackBy + 6*%1],edx
                mov             dword[esi + AttackBy + ATYPE*%2 + 6*%1],ebp
                add             [esi + AttackLen + ATYPE*%2 + 6*%1], ecx
%%Att5:         add             [esi + AttackBy + 5*%1],edx
                mov             dword[esi + AttackBy + ATYPE*%2 + 5*%1],ebp
                add             [esi + AttackLen + ATYPE*%2 + 5*%1], ecx
%%Att4:         add             [esi + AttackBy + 4*%1],edx
                mov             dword[esi + AttackBy + ATYPE*%2 + 4*%1],ebp
                add             [esi + AttackLen + ATYPE*%2 + 4*%1], ecx
%%Att3:         add             [esi + AttackBy + 3*%1],edx
                mov             dword[esi + AttackBy + ATYPE*%2 + 3*%1],ebp
                add             [esi + AttackLen + ATYPE*%2 + 3*%1], ecx
%%Att2:         add             [esi + AttackBy + 2*%1],edx
                mov             dword[esi + AttackBy + ATYPE*%2 + 2*%1],ebp
                add             [esi + AttackLen + ATYPE*%2 + 2*%1], ecx
%%Att1:         add             [esi + AttackBy + 1*%1],edx
                mov             dword[esi + AttackBy + ATYPE*%2 + 1*%1],ebp
                add             [esi + AttackLen + ATYPE*%2 + 1*%1], ecx
%%Att0:
%endmacro
;*****************************************************************************
%macro          clrAttackvec    3
                mov             edx,[esi + AttackBy + ATYPE*%2]
                mov             ebp,edx
                sub             edx,ebp                  ;case %3 = 0 (ecx) :if no vector set, all fields will be empty, so we dont need to clear the vector
                je              %%endvec                ;case %3 = ATTACK: if exactly the same Attack was stored there before, we dont need to change anything (only happen with 2 rooks)
%assign         off             %1
%rep            6
                add             [esi + AttackBy + off],edx
                cmp             ecx,[esi + Board + off]
                mov             dword[esi + AttackBy + ATYPE*%2 + off],ebp
                jne             %%endvec
%assign         off             off+%1
%endrep
                add             [esi + AttackBy + off],edx
                mov             dword[esi + AttackBy + ATYPE*%2 + off],ebp
                jmp             short %%endvec
                align           8
%%endvec:
%endmacro
;******************************************************************************

%macro          clrpiece_m        2                       ;Color

%assign         PAWN_ATTACK     1<<(8-8*%1)            ;2
%assign         BISHOP_ATTACK   1<<(2+8-8*%1)           ;1
%assign         KNIGHT_ATTACK   1<<(5+8-8*%1)            ;2
%assign         ROOK_ATTACK     1<<(8+8-8*%1)             ;2 bits for rooks
%assign         QUEEN_ATTACK    1<<(11+8-8*%1)             ;1
%assign         KING_ATTACK     1<<(14+8-8*%1)           ;1

;counter Attacks
%assign         PAWN_CATTACK     1<<(8+8*%1)            ;2
%assign         BISHOP_CATTACK   1<<(2+8+8*%1)           ;1
%assign         KNIGHT_CATTACK   1<<(5+8+8*%1)            ;2
%assign         ROOK_CATTACK     1<<(8+8+8*%1)             ;2 bits for rooks
%assign         QUEEN_CATTACK    1<<(11+8+8*%1)             ;1
%assign         KING_CATTACK     1<<(14+8+8*%1)           ;1

                sal             eax,6
                mov             ecx,[eax+Pieces]        ;# of Pieces of this type
                dec             dword[eax+Pieces]            ;inc # of Pieces of this type
                lea             eax,[eax+ecx*4+Pieces]       ;adr of last piece in list
                xor             edi,edi                 ;piece behind last piece

%%searchlp:     mov             edx,[eax]
                mov             [eax],edi
                lea             eax,[eax-4]
                cmp             edx,esi
                jz              %%foundPiece
                mov             edi,edx
                jmp             %%searchlp

%%foundPiece:   mov             eax,ebp
                mov             dword[esi + Board   ],0      ;store piece in Board

                lea             ecx,[eax*2 + 6*ATYPE + hashKeys]

                movq            mm0,[mainHashKey]
                pxor            mm0,[ecx + 2*esi]
                movq            [mainHashKey],mm0
                movq            mm0,[pawnHashKey]
                pxor            mm0,[ecx + 2*esi + 64]
                movq            [pawnHashKey],mm0
                emms

                sar             eax,7
                jmp             [clrJmpTable+eax]

                align           8
clrRook%2:      clrAttackvec    row, 1, ROOK_ATTACK
                clrAttackvec    col, 3, ROOK_ATTACK
                clrAttackvec    -row,5, ROOK_ATTACK
                clrAttackvec    -col,7, ROOK_ATTACK
                clrAttackvec    row+col, 2, 0
                clrAttackvec    -row+col,4, 0
                clrAttackvec    -row-col,6, 0
                clrAttackvec    row-col, 8, 0
                popa
                ret

                align           8
clrBishop%2:    clrAttackvec    row+col, 2, BISHOP_ATTACK
                clrAttackvec    -row+col,4, BISHOP_ATTACK
                clrAttackvec    -row-col,6, BISHOP_ATTACK
                clrAttackvec    row-col, 8, BISHOP_ATTACK
                clrAttackvec    row, 1, 0
                clrAttackvec    col, 3, 0
                clrAttackvec    -row,5, 0
                clrAttackvec    -col,7, 0
                popa
                ret

                align           8
clrQueen%2:     clrAttackvec    row,    1,QUEEN_ATTACK
                clrAttackvec    col,    3,QUEEN_ATTACK
                clrAttackvec    -row,   5,QUEEN_ATTACK
                clrAttackvec    -col,   7,QUEEN_ATTACK
                clrAttackvec    row+col, 2,QUEEN_ATTACK
                clrAttackvec    -row+col,4,QUEEN_ATTACK
                clrAttackvec    -row-col,6,QUEEN_ATTACK
                clrAttackvec    row-col, 8,QUEEN_ATTACK
                popa
                ret

                align           8
clrKnight%2:    sub             dword[esi + AttackBy + 2*row +   col], KNIGHT_ATTACK
                sub             dword[esi + AttackBy + 2*row -   col], KNIGHT_ATTACK
                sub             dword[esi + AttackBy - 2*row +   col], KNIGHT_ATTACK
                sub             dword[esi + AttackBy - 2*row -   col], KNIGHT_ATTACK
                sub             dword[esi + AttackBy + 1*row + 2*col], KNIGHT_ATTACK
                sub             dword[esi + AttackBy + 1*row - 2*col], KNIGHT_ATTACK
                sub             dword[esi + AttackBy - 1*row + 2*col], KNIGHT_ATTACK
                sub             dword[esi + AttackBy - 1*row - 2*col], KNIGHT_ATTACK
                jmp             %%clrvecs

                align           8
clrKing%2:      sub             dword[esi + AttackBy + row +   col], KING_ATTACK
                sub             dword[esi + AttackBy + row -   col], KING_ATTACK
                sub             dword[esi + AttackBy - row +   col], KING_ATTACK
                sub             dword[esi + AttackBy - row -   col], KING_ATTACK
                sub             dword[esi + AttackBy + row], KING_ATTACK
                sub             dword[esi + AttackBy - row], KING_ATTACK
                sub             dword[esi + AttackBy + col], KING_ATTACK
                sub             dword[esi + AttackBy - col], KING_ATTACK
                jmp             %%clrvecs
                
                align           8
clrPawn%2:      sub             dword[esi + AttackBy + %1*row +   col], PAWN_ATTACK
                sub             dword[esi + AttackBy + %1*row -   col], PAWN_ATTACK
%%clrvecs:      clrAttackvec    row,    1,0
                clrAttackvec    col,    3,0
                clrAttackvec    -row,   5,0
                clrAttackvec    -col,   7,0
                clrAttackvec    row+col, 2,0
                clrAttackvec    -row+col,4,0
                clrAttackvec    -row-col,6,0
                clrAttackvec    row-col, 8,0
                
                popa
                ret

%ifdef          attacks
                mov             edi,[esp+28]
                neg             edi
                cmovs           edi,[esp+28]
                mov             [temp],edi
                mov             ebp,[edi*4 + attack_q_file]
                mov             ecx,[edi*4 + attack_r]

                clrAttackflag    col, ROOK ,%1, 0
                clrAttackflag    row, ROOK ,%1, 2
                clrAttackflag   -col, ROOK ,%1, 4
                clrAttackflag   -row, ROOK ,%1, 6

                mov             edi,[temp]
                mov             ebp,[edi*4 + attack_q_dia]
                mov             ecx,[edi*4 + attack_b]

                clrAttackflag    row+col, BISHOP ,%1, 1
                clrAttackflag    row-col, BISHOP ,%1, 3
                clrAttackflag   -row-col, BISHOP ,%1, 5
                clrAttackflag   -row+col, BISHOP ,%1, 7

                mov             edi,[temp]
                mov             eax,[edi*4 + attack_n]
                sub             dword[esi+Attacks + 2*row +   col - KNIGHT*ATYPE*%1], eax
                sub             dword[esi+Attacks + 2*row -   col - KNIGHT*ATYPE*%1], eax
                sub             dword[esi+Attacks - 2*row +   col - KNIGHT*ATYPE*%1], eax
                sub             dword[esi+Attacks - 2*row -   col - KNIGHT*ATYPE*%1], eax
                sub             dword[esi+Attacks + 1*row + 2*col - KNIGHT*ATYPE*%1], eax
                sub             dword[esi+Attacks + 1*row - 2*col - KNIGHT*ATYPE*%1], eax
                sub             dword[esi+Attacks - 1*row + 2*col - KNIGHT*ATYPE*%1], eax
                sub             dword[esi+Attacks - 1*row - 2*col - KNIGHT*ATYPE*%1], eax

                mov             eax,[edi*4 + attack_p]
                sub             dword[esi+Attacks + %1*row + col - PAWN*ATYPE*%1], eax
                sub             dword[esi+Attacks + %1*row - col - PAWN*ATYPE*%1], eax

%%fastret:      popa
                ret
%endif
%endmacro

putpiece:       cmp             dword[esp+4],0
                js              putpiece_s
                putpiece_m      1,w
putpiece_s:     putpiece_m     -1,b

fastret:        popa
                ret

clrpiece:       pusha
                mov             esi,[esp+36]             ;destination
                movsx           eax,word[esi + Board]       ;type
                mov             ebp,eax                 ;store for later use
                sar             eax,9
                mov             [esp+28],eax
                jz              fastret
                js              clrpiece_s
                clrpiece_m      1,w
clrpiece_s:     clrpiece_m     -1,b

;*****************************************************************************
;*****************************************************************************
%macro          clrAttack       3                       ;restores attack vectors if a piece is cleared
                mov             edx,[esi + AttackBy + ATYPE*%2] ;old atteckvector
                mov             ebp,edx                         ;store for later use
                sub             edx,%3                  ;case %3 = 0 (ecx) :if no vector set, all fields will be empty, so we dont need to clear the vector
                je              %%endvec                ;case %3 = ATTACK: if exactly the same Attack was stored there before, we dont need to change anything (only happen with 2 rooks)
%assign         off             %1
%rep            6
                add             [esi + AttackBy + off],edx
                cmp             ecx,[esi + Board + off]
                mov             [esi + AttackBy + ATYPE*%2 + off],ebp
                jne             short %%endvec
%assign         off             off+%1
%endrep
                add             [esi + AttackBy + off],edx
                mov             [esi + AttackBy + ATYPE*%2 + off],ebp
                jmp             short %%endvec
                align           8
%%endvec:
%endmacro
;******************************************************************************
%macro          setAttack       3                       ;deletes/change attack vectors for new piece blocking/adding attack lines
                mov             edx,[edi + AttackBy + ATYPE*%2]
                sub             edx,%3                  ;case %3 = 0 (ecx) :if no vector set, all fields will be empty, so we dont need to clear the vector
                je              %%endvec                ;case %3 = ATTACK: if exactly the same Attack was stored there before, we dont need to change anything (only happen with 2 rooks)
%assign         off             %1
%rep            6
                sub             [edi + AttackBy + off],edx
                cmp             ecx,[edi + Board + off]
                mov             dword[edi + AttackBy + ATYPE*%2 + off],%3
                jne             short %%endvec
%assign         off             off+%1
%endrep
                sub             [edi + AttackBy + off],edx
                mov             dword[edi + AttackBy + ATYPE*%2 + off],%3
                jmp             short %%endvec
                align           8
%%endvec:
%endmacro
;******************************************************************************

%assign         PAWN_ATTACK     1                      ;2
%assign         BISHOP_ATTACK   1 << 2                 ;1
%assign         KNIGHT_ATTACK   1 << 5                 ;2
%assign         ROOK_ATTACK     1 << 8                 ;2 bits for rooks
%assign         QUEEN_ATTACK    1 << 11                ;1
%assign         KING_ATTACK     1 << 14                ;1


movepiece:      pusha
                mov             esi,[esp+36]            ;source
                mov             edi,[esp+40]            ;destination

                movsx           ebx,word[Board + esi]
                mov             edx,ebx                 ;store piece type for later use in edx
                sar             ebx,3
                mov             ecx,[ebx+Pieces]        ;# of Pieces of this type
                lea             ebx,[ebx+ecx*4+Pieces]  ;adr of last piece in list

searchlp:       cmp             esi,[ebx]               ;find piece at source position
                lea             ebx,[ebx-4]
                jnz             searchlp
                mov             [ebx+4],edi
                
                lea             ecx,[edx*2 + 6*ATYPE + hashKeys]        ;hashkey[6+type][0][0] preload
                sar             edx,7

                mov             ebx, [Board + esi]      ;put piece on new position on the board
                mov             [Board + edi], ebx      ;but dont clear old postion
                
                lea             eax,[ecx + 2*esi]
                
                movq            mm0,[mainHashKey]
                pxor            mm0,[ecx + 2*esi]
                pxor            mm0,[ecx + 2*edi]
                movq            [mainHashKey],mm0
                emms

                mov             eax,[attackTable + edx]
                jmp             [jmptable + edx]

                align           8
rook_c:         xor             ecx,ecx                 ;ecx := 0
                setAttack       row, 1, eax
                setAttack       col, 3, eax
                setAttack       -row,5, eax
                setAttack       -col,7, eax
                setAttack       row+col, 2, ecx
                setAttack       -row+col,4, ecx
                setAttack       -row-col,6, ecx
                setAttack       row-col, 8, ecx

                mov             [Board + esi],ecx
                clrAttack       row, 1, eax
                clrAttack       col, 3, eax
                clrAttack       -row,5, eax
                clrAttack       -col,7, eax
                clrAttack       row+col, 2, ecx
                clrAttack       -row+col,4, ecx
                clrAttack       -row-col,6, ecx
                clrAttack       row-col, 8, ecx
                popa
                ret

                align           8
bishop_c:       xor             ecx,ecx                 ;ecx := 0
                setAttack       row+col, 2, eax
                setAttack       -row+col,4, eax
                setAttack       -row-col,6, eax
                setAttack       row-col, 8, eax
                setAttack       row, 1, ecx
                setAttack       col, 3, ecx
                setAttack       -row,5, ecx
                setAttack       -col,7, ecx

                mov             [Board + esi],ecx
                clrAttack       row+col, 2, eax
                clrAttack       -row+col,4, eax
                clrAttack       -row-col,6, eax
                clrAttack       row-col, 8, eax
                clrAttack       row, 1, ecx
                clrAttack       col, 3, ecx
                clrAttack       -row,5, ecx
                clrAttack       -col,7, ecx
                popa
                ret

                align           8
queen_c:        xor             ecx,ecx                 ;ecx := 0
                setAttack       row,    1,eax
                setAttack       col,    3,eax
                setAttack       -row,   5,eax
                setAttack       -col,   7,eax
                setAttack       row+col, 2,eax
                setAttack       -row+col,4,eax
                setAttack       -row-col,6,eax
                setAttack       row-col, 8,eax

                mov             [Board + esi],ecx
                clrAttack       row,    1,eax
                clrAttack       col,    3,eax
                clrAttack       -row,   5,eax
                clrAttack       -col,   7,eax
                clrAttack       row+col, 2,eax
                clrAttack       -row+col,4,eax
                clrAttack       -row-col,6,eax
                clrAttack       row-col, 8,eax
                popa
                ret

                align           8
knight_c:       add             dword[edi + AttackBy + 2*row +   col], eax
                add             dword[edi + AttackBy + 2*row -   col], eax
                add             dword[edi + AttackBy - 2*row +   col], eax
                add             dword[edi + AttackBy - 2*row -   col], eax
                add             dword[edi + AttackBy + 1*row + 2*col], eax
                add             dword[edi + AttackBy + 1*row - 2*col], eax
                add             dword[edi + AttackBy - 1*row + 2*col], eax
                add             dword[edi + AttackBy - 1*row - 2*col], eax
                sub             dword[esi + AttackBy + 2*row +   col], eax
                sub             dword[esi + AttackBy + 2*row -   col], eax
                sub             dword[esi + AttackBy - 2*row +   col], eax
                sub             dword[esi + AttackBy - 2*row -   col], eax
                sub             dword[esi + AttackBy + 1*row + 2*col], eax
                sub             dword[esi + AttackBy + 1*row - 2*col], eax
                sub             dword[esi + AttackBy - 1*row + 2*col], eax
                sub             dword[esi + AttackBy - 1*row - 2*col], eax
                jmp             clrvecs

                align           8
pawn_b:         movq            mm0,[pawnHashKey]
                pxor            mm0,[ecx + 2*esi + 64]
                pxor            mm0,[ecx + 2*edi + 64]
                movq            [pawnHashKey],mm0
                emms
                add             dword[edi + AttackBy - row +   col], eax
                add             dword[edi + AttackBy - row -   col], eax
                sub             dword[esi + AttackBy - row +   col], eax
                sub             dword[esi + AttackBy - row -   col], eax
                jmp             clrvecs

                align           8
pawn_w:         movq            mm0,[pawnHashKey]
                pxor            mm0,[ecx + 2*esi + 64]
                pxor            mm0,[ecx + 2*edi + 64]
                movq            [pawnHashKey],mm0
                emms
                add             dword[edi + AttackBy + row +   col], eax
                add             dword[edi + AttackBy + row -   col], eax
                sub             dword[esi + AttackBy + row +   col], eax
                sub             dword[esi + AttackBy + row -   col], eax
                jmp             clrvecs

                align           8
king_c:		add             dword[edi + AttackBy + row +   col], eax
                add             dword[edi + AttackBy + row -   col], eax
                add             dword[edi + AttackBy - row +   col], eax
                add             dword[edi + AttackBy - row -   col], eax
                add             dword[edi + AttackBy + row], eax
                add             dword[edi + AttackBy - row], eax
                add             dword[edi + AttackBy + col], eax
                add             dword[edi + AttackBy - col], eax

                sub             dword[esi + AttackBy + row +   col], eax
                sub             dword[esi + AttackBy + row -   col], eax
                sub             dword[esi + AttackBy - row +   col], eax
                sub             dword[esi + AttackBy - row -   col], eax
                sub             dword[esi + AttackBy + row], eax
                sub             dword[esi + AttackBy - row], eax
                sub             dword[esi + AttackBy + col], eax
                sub             dword[esi + AttackBy - col], eax

clrvecs:        xor             ecx,ecx                 ;ecx := 0
                test            dword[AttackBy + edi], ( ROOK_ATTACK + BISHOP_ATTACK + QUEEN_ATTACK ) * 0x70007
                jz              no_dstrangeatt  ;destination not attacked/defended by any long range piece

                setAttack       row,    1,ecx   ;delete blocked attack lines
                setAttack       col,    3,ecx
                setAttack       -row,   5,ecx
                setAttack       -col,   7,ecx
                setAttack       row+col, 2,ecx
                setAttack       -row+col,4,ecx
                setAttack       -row-col,6,ecx
                setAttack       row-col, 8,ecx

no_dstrangeatt: mov             [Board + esi],ecx       ;actually delete piece
                test            dword[AttackBy + esi], ( ROOK_ATTACK + BISHOP_ATTACK + QUEEN_ATTACK ) * 0x70007
                jz              no_rangeattack  ;source not attacked/defended by any long range piece

                clrAttack       row,    1,ecx   ;restore openend attack lines
                clrAttack       col,    3,ecx
                clrAttack       -row,   5,ecx
                clrAttack       -col,   7,ecx
                clrAttack       row+col, 2,ecx
                clrAttack       -row+col,4,ecx
                clrAttack       -row-col,6,ecx
                clrAttack       row-col, 8,ecx

no_rangeattack: popa
                ret

prehash:        pusha
                xor             ecx,ecx
                mov             esi,[esp+36]            ;source
                mov             edi,[esp+40]            ;destination

                movsx           eax,word[Board + esi]
                lea             eax,[eax*2 + 6*ATYPE + hashKeys]        ;hashkey[6+type][0][0] preload
                movsx           ebx,word[Board + edi]
                lea             ebx,[ebx*2 + 6*ATYPE + hashKeys]        ;hashkey[6+type][0][0] preload

                movq            mm0,[mainHashKey]
                pxor            mm0,[eax + 2*esi]
                pxor            mm0,[eax + 2*edi]
                pxor            mm0,[ebx + 2*edi]
                movd            eax,mm0
                xor             eax,[color]
                xor             eax,0xfffffffe      ; <=> xor,-[color]
                and             eax,[mainHash + 8]
                shl             eax,4
                add             eax,[mainHash + 12]
%ifdef DOUBLEHASH
                movq            mm1,mm0
%endif
                pxor            mm0,[eax]
                movq            [temp],mm0
                movd            ebx,mm0
                or              ebx,[temp+4]
%ifdef DOUBLEHASH
                jz              ph_found
                lea             eax, [eax+16]
                pxor            mm1,[eax]
                movq            [temp],mm1
                movd            ebx,mm1
                or              ebx,[temp+4]
                jz              ph_found   
%else                
                cmovz           ecx,eax
%endif
                mov             [esp+28],ecx
                emms
                popa
                ret
      
ph_found:       mov             [esp+28],eax
                emms    
                popa
                ret          
                                
;typedef struct {
;    unsigned    size;
;    unsigned    count;
;    unsigned    mask;
;    void        *table;
;    double      read;
;    double      write;
;    unsigned    fill;
;} HashInfo;
;mainHash.table + ((mainHashKey ^ -color) & mainHash.mask);
                
;                emms

extern          printBoard

;*******************************************************************************

SECTION         .data
;                db              0x40,1,3,9,3,5
;values:         db              0,5,3,9,3,1,0x40

;values for attacking a piece in column with a piece in row
;table above is mirrored for black.
; 0 more valuable piece is attacking less or equal valuable and is attacked back by the less valuable.
; 1 more valuable piece is attacking less or equal valuable.
; 4 less valuable piece is attacking more valuable and ist attacked back
;16 less valuable piece is attacking more valuable.


                align          16
;                                   R   B   Q   N   P   K
attack_p:       dd              0, 0x1000,  0x400,  0x400, 0x1000,     0, 0x2000, 0
attack_n:       dd              0, 0x1000, 0x1000, 0x1000,  0    , 0x100, 0x2000, 0
attack_b:       dd              0, 0x1000,  0,      0x400,  0x100, 0x100, 0x2000, 0
attack_r:       dd              0,      0,  0x100,  0x400,  0x100, 0x100, 0x2000, 0
attack_q_file:  dd              0,      0,  0x100,      0,  0x100, 0x100, 0x2000, 0
attack_q_dia:   dd              0, 0x1000,      0,      0,  0x100, 0x100, 0x2000, 0

                dd               KING_ATTACK << 16, PAWN_ATTACK << 16, KNIGHT_ATTACK << 16, QUEEN_ATTACK << 16, BISHOP_ATTACK << 16, ROOK_ATTACK << 16
attackTable:    dd               0, ROOK_ATTACK, BISHOP_ATTACK, QUEEN_ATTACK, KNIGHT_ATTACK, PAWN_ATTACK, KING_ATTACK

                dd              king_c, pawn_b, knight_c, queen_c, bishop_c, rook_c,
jmptable:       dd              printBoard, rook_c, bishop_c, queen_c, knight_c, pawn_w, king_c

                dd              putKingb, putPawnb, putKnightb, putQueenb, putBishopb, putRookb
putJmpTable:    dd              0, putRookw, putBishopw, putQueenw, putKnightw, putPawnw, putKingw

                dd              clrKingb, clrPawnb, clrKnightb, clrQueenb, clrBishopb, clrRookb
clrJmpTable:    dd              0, clrRookw, clrBishopw, clrQueenw, clrKnightw, clrPawnw, clrKingw

SECTION         .bss

temp:           resq            1
list1:          resb            16
list2:          resb            16

hash:           resq            7531
