/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef STATVIEW_H
#define STATVIEW_H

#include <qtextedit.h>

class QTimer;
class Engine;
class Game;
/**
@author Gunther Piez
*/
class StatView : public QTextEdit
{
Q_OBJECT
public:
    StatView(QWidget *parent , Game *g, Engine *e);

    ~StatView();

    void setRefresh(int);
    int getRefresh() { return refresh; }
    Engine *engine;
    Game *game;

protected slots:
    void updateStats();

protected:
    int refresh;
    QTimer *refreshTimer;
};

#endif
