/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef LISTVIEW_H
#define LISTVIEW_H

#include "view.h"
#include "game.h"

#include <qwidget.h>

class    QTextEdit;
class    QLineEdit;
class Game;

/**
class for a move list widget

@author Gunther Piez
*/
class ListView : public QWidget
{
Q_OBJECT
public:
    ListView(QWidget *parent , Game *);

    ~ListView();

    void setMoveList(Pgn *list);

    QTextEdit *lb;
    QLineEdit *le;
    Game *game;
    
    int movePos[5000];
    
signals:
    void enterEvent(QEvent *);
    void leaveEvent(QEvent *);
    void clicked(int, int);
};

#endif
