/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "config.h"

#include "eval.h"
#include <dirent.h>
#include <fnmatch.h>
#include <malloc.h>
#include <stdbool.h>

int endgame(Board * b, float *val)
{
    unsigned int hash;
    int i;

    hash = 0;
    for (i = -PAWN; i <= PAWN; i++)
        if (i)
            hash += CNT(i);
    if (hash > 3)
        return false;
    else {
        if (hash == 0) {
            *val = drawValue;
            return true;
        } else
            return false;
    }
}

int sel(const struct dirent *d)
{
//    if (fnmatch("*.[0-9][0-9][0-9]", d->d_name)) return true;
    if (fnmatch("*.eg", d->d_name, 0))
        return true;
    return false;
}


#ifndef HAVE_VERSIONSORT
int versionsort() {
    return 0;
}
#endif

void initEndgame()
{
    struct dirent **namelist;

    int n = scandir("eg", &namelist, sel, versionsort);

    if (n < 0)
        return;

    while (n--) {

        free(namelist[n]);
    }
    free(namelist);
}
