/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef SEARCH_H
#define SEARCH_H
#include "board.h"

void searchm(int);

extern Move breakMove, returnMove, ponderMove;
extern unsigned long long t0, t1, solutionTime;
extern int currDepth;
#ifdef MYDEBUG
extern unsigned long long moveord[64][11];
#endif

extern Move returnMove, ponderMove;
#endif

extern int extHorizon;
extern int extCheck;
extern int extRecapture;
extern int extMate;
extern int extPawn;

